/* ###################################### */
/* #                                    # */
/* #  Un compilateur pour le langage    # */
/* #        ALGO                        # */
/* #                                    # */
/* # Machine RISC                       # */
/* # Emmanuel Bruno                     # */
/* # bruno@univ-tln.fr                  # */
/* ###################################### */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "algo_risc.h"


int main() {
    risc_init();
  /* Exemple de creation d"un programme assembleur (une boucle)*/
  
    put(i_addi,1,0,3);  //PAS 
    put(i_addi,2,0,10); //Valeur initiale
    put(i_stw,2,0,1012);
    put(i_stw,1,0,1008);


    put(i_ldw,1,0,1012);
    put(i_ldw,2,0,1008);
    put(i_sub,1,1,2);
    put(i_addi,3,3,1);
    put(i_bgt,1,0,-2);
    put(i_stw,1,0,1000);
    put(i_stw,3,0,1004);
    put(i_hrs,0,0,1);
  

    printf("# -- Code cree. -- #\n");


  /* Affichage des code mnemoniques */
  decode(code, lastinst);

  /* Chargement du code en memoire */   
  load(code,lastinst);   
  /* execution*/
  printf("# -- Execution du code -- #\n");
  execute(0);
}
